=== debian/changelog ===
jacal (1c8-1) unstable; urgency=medium

  * simply debian/watch and also get it to work
  * forward port patches
  * Update standards version to 4.6.2, no changes needed.

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 11 Jan 2023 16:39:16 +0000
