=== debian/control ===
Source: jacal
Section: math
Priority: optional
Maintainer: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: texi2html, texinfo
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://people.csail.mit.edu/jaffer/JACAL
Vcs-Git: https://salsa.debian.org/debian/jacal.git
Vcs-Browser: https://salsa.debian.org/debian/jacal

Package: jacal
Architecture: all
Depends: ${misc:Depends}, scm, slib (>= 3a5-1)
Description: Interactive symbolic math system
 JACAL is an interactive symbolic math system which can manipulate and
 simplify equations, scalars, vectors, and matrices of single and
 multiple valued algebraic expressions containing numbers, variables,
 radicals, and algebraic differential, and holonomic functions.
