=== debian/watch ===
version=4
https://people.csail.mit.edu/jaffer/JACAL .*/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
